var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/geo/edge_insets.ts
var edge_insets_exports = {};
__export(edge_insets_exports, {
  default: () => EdgeInsets
});
module.exports = __toCommonJS(edge_insets_exports);
var import_util = require("../util");
var import_point = __toESM(require("./point"));
var EdgeInsets = class {
  constructor(top = 0, bottom = 0, left = 0, right = 0) {
    if (isNaN(top) || top < 0 || isNaN(bottom) || bottom < 0 || isNaN(left) || left < 0 || isNaN(right) || right < 0) {
      throw new Error("Invalid value for edge-insets, top, bottom, left and right must all be numbers");
    }
    this.top = top;
    this.bottom = bottom;
    this.left = left;
    this.right = right;
  }
  interpolate(start, target, t) {
    if (target.top != null && start.top != null) {
      this.top = (0, import_util.interpolate)(start.top, target.top, t);
    }
    if (target.bottom != null && start.bottom != null) {
      this.bottom = (0, import_util.interpolate)(start.bottom, target.bottom, t);
    }
    if (target.left != null && start.left != null) {
      this.left = (0, import_util.interpolate)(start.left, target.left, t);
    }
    if (target.right != null && start.right != null) {
      this.right = (0, import_util.interpolate)(start.right, target.right, t);
    }
    return this;
  }
  getCenter(width, height) {
    const x = (0, import_util.clamp)((this.left + width - this.right) / 2, 0, width);
    const y = (0, import_util.clamp)((this.top + height - this.bottom) / 2, 0, height);
    return new import_point.default(x, y);
  }
  equals(other) {
    return this.top === other.top && this.bottom === other.bottom && this.left === other.left && this.right === other.right;
  }
  clone() {
    return new EdgeInsets(this.top, this.bottom, this.left, this.right);
  }
  toJSON() {
    return {
      top: this.top,
      bottom: this.bottom,
      left: this.left,
      right: this.right
    };
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
