var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/geo/lng_lat_bounds.ts
var lng_lat_bounds_exports = {};
__export(lng_lat_bounds_exports, {
  default: () => LngLatBounds
});
module.exports = __toCommonJS(lng_lat_bounds_exports);
var import_lng_lat = __toESM(require("./lng_lat"));
var LngLatBounds = class {
  static convert(input) {
    if (input instanceof LngLatBounds) {
      return input;
    }
    return new LngLatBounds(input);
  }
  constructor(sw, ne) {
    if (!sw) {
    } else if (ne) {
      this.setSouthWest(sw).setNorthEast(ne);
    } else if (sw.length === 4) {
      this.setSouthWest([sw[0], sw[1]]).setNorthEast([sw[2], sw[3]]);
    } else {
      this.setSouthWest(sw[0]).setNorthEast(sw[1]);
    }
  }
  setNorthEast(ne) {
    this.ne = ne instanceof import_lng_lat.default ? new import_lng_lat.default(ne.lng, ne.lat) : import_lng_lat.default.convert(ne);
    return this;
  }
  setSouthWest(sw) {
    this.sw = sw instanceof import_lng_lat.default ? new import_lng_lat.default(sw.lng, sw.lat) : import_lng_lat.default.convert(sw);
    return this;
  }
  extend(obj) {
    const sw = this.sw;
    const ne = this.ne;
    let sw2;
    let ne2;
    if (obj instanceof import_lng_lat.default) {
      sw2 = obj;
      ne2 = obj;
    } else if (obj instanceof LngLatBounds) {
      sw2 = obj.sw;
      ne2 = obj.ne;
      if (!sw2 || !ne2) {
        return this;
      }
    } else {
      if (Array.isArray(obj)) {
        if (obj.length === 4 || obj.every(Array.isArray)) {
          const lngLatBoundsObj = obj;
          return this.extend(LngLatBounds.convert(lngLatBoundsObj));
        } else {
          const lngLatObj = obj;
          return this.extend(import_lng_lat.default.convert(lngLatObj));
        }
      }
      return this;
    }
    if (!sw && !ne) {
      this.sw = new import_lng_lat.default(sw2.lng, sw2.lat);
      this.ne = new import_lng_lat.default(ne2.lng, ne2.lat);
    } else {
      sw.lng = Math.min(sw2.lng, sw.lng);
      sw.lat = Math.min(sw2.lat, sw.lat);
      ne.lng = Math.max(ne2.lng, ne.lng);
      ne.lat = Math.max(ne2.lat, ne.lat);
    }
    return this;
  }
  getCenter() {
    return new import_lng_lat.default((this.sw.lng + this.ne.lng) / 2, (this.sw.lat + this.ne.lat) / 2);
  }
  getSouthWest() {
    return this.sw;
  }
  getNorthEast() {
    return this.ne;
  }
  getNorthWest() {
    return new import_lng_lat.default(this.getWest(), this.getNorth());
  }
  getSouthEast() {
    return new import_lng_lat.default(this.getEast(), this.getSouth());
  }
  getWest() {
    return this.sw.lng;
  }
  getSouth() {
    return this.sw.lat;
  }
  getEast() {
    return this.ne.lng;
  }
  getNorth() {
    return this.ne.lat;
  }
  toArray() {
    return [this.sw.toArray(), this.ne.toArray()];
  }
  toString() {
    return `LngLatBounds(${this.sw.toString()}, ${this.ne.toString()})`;
  }
  isEmpty() {
    return !(this.sw && this.ne);
  }
  contains(lnglat) {
    const { lng, lat } = import_lng_lat.default.convert(lnglat);
    const containsLatitude = this.sw.lat <= lat && lat <= this.ne.lat;
    let containsLongitude = this.sw.lng <= lng && lng <= this.ne.lng;
    if (this.sw.lng > this.ne.lng) {
      containsLongitude = this.sw.lng >= lng && lng >= this.ne.lng;
    }
    return containsLatitude && containsLongitude;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
