var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/geo/mercator.ts
var mercator_exports = {};
__export(mercator_exports, {
  altitudeFromMercatorZ: () => altitudeFromMercatorZ,
  default: () => MercatorCoordinate,
  latFromMercatorY: () => latFromMercatorY,
  lngFromMercatorX: () => lngFromMercatorX,
  mercatorScale: () => mercatorScale,
  mercatorXfromLng: () => mercatorXfromLng,
  mercatorYfromLat: () => mercatorYfromLat,
  mercatorZfromAltitude: () => mercatorZfromAltitude
});
module.exports = __toCommonJS(mercator_exports);
var import_lng_lat = __toESM(require("../geo/lng_lat"));
var earthCircumfrence = 2 * Math.PI * import_lng_lat.earthRadius;
function circumferenceAtLatitude(latitude) {
  return earthCircumfrence * Math.cos(latitude * Math.PI / 180);
}
function mercatorXfromLng(lng) {
  return (180 + lng) / 360;
}
function mercatorYfromLat(lat) {
  return (180 - 180 / Math.PI * Math.log(Math.tan(Math.PI / 4 + lat * Math.PI / 360))) / 360;
}
function mercatorZfromAltitude(altitude, lat) {
  return altitude / circumferenceAtLatitude(lat);
}
function lngFromMercatorX(x) {
  return x * 360 - 180;
}
function latFromMercatorY(y) {
  const y2 = 180 - y * 360;
  return 360 / Math.PI * Math.atan(Math.exp(y2 * Math.PI / 180)) - 90;
}
function altitudeFromMercatorZ(z, y) {
  return z * circumferenceAtLatitude(latFromMercatorY(y));
}
function mercatorScale(lat) {
  return 1 / Math.cos(lat * Math.PI / 180);
}
var MercatorCoordinate = class {
  static fromLngLat(lngLatLike, altitude = 0) {
    const lngLat = import_lng_lat.default.convert(lngLatLike);
    return new MercatorCoordinate(mercatorXfromLng(lngLat.lng), mercatorYfromLat(lngLat.lat), mercatorZfromAltitude(altitude, lngLat.lat));
  }
  constructor(x, y, z = 0) {
    this.x = +x;
    this.y = +y;
    this.z = +z;
  }
  toLngLat() {
    return new import_lng_lat.default(lngFromMercatorX(this.x), latFromMercatorY(this.y));
  }
  toAltitude() {
    return altitudeFromMercatorZ(this.z, this.y);
  }
  meterInMercatorCoordinateUnits() {
    return 1 / earthCircumfrence * mercatorScale(latFromMercatorY(this.y));
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  altitudeFromMercatorZ,
  latFromMercatorY,
  lngFromMercatorX,
  mercatorScale,
  mercatorXfromLng,
  mercatorYfromLat,
  mercatorZfromAltitude
});
