var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/blockable_map_event.ts
var blockable_map_event_exports = {};
__export(blockable_map_event_exports, {
  default: () => BlockableMapEventHandler
});
module.exports = __toCommonJS(blockable_map_event_exports);
var import_events = require("./events");
var BlockableMapEventHandler = class {
  constructor(map) {
    this.map = map;
  }
  reset() {
    this.delayContextMenu = false;
    delete this.contextMenuEvent;
  }
  mousemove(e) {
    this.map.emit(e.type, new import_events.MapMouseEvent(e.type, this.map, e));
  }
  mousedown() {
    this.delayContextMenu = true;
  }
  mouseup() {
    this.delayContextMenu = false;
    if (this.contextMenuEvent) {
      this.map.emit("contextmenu", new import_events.MapMouseEvent("contextmenu", this.map, this.contextMenuEvent));
      delete this.contextMenuEvent;
    }
  }
  contextmenu(e) {
    if (this.delayContextMenu) {
      this.contextMenuEvent = e;
    } else {
      this.map.emit(e.type, new import_events.MapMouseEvent(e.type, this.map, e));
    }
    if (this.map.listeners("contextmenu")) {
      e.preventDefault();
    }
  }
  isEnabled() {
    return true;
  }
  isActive() {
    return false;
  }
  enable() {
    return true;
  }
  disable() {
    return false;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
