var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/map_event.ts
var map_event_exports = {};
__export(map_event_exports, {
  default: () => MapEventHandler
});
module.exports = __toCommonJS(map_event_exports);
var import_events = require("./events");
var MapEventHandler = class {
  constructor(map, options) {
    this.map = map;
    this.clickTolerance = options.clickTolerance;
  }
  reset() {
    delete this.mousedownPos;
  }
  wheel(e) {
    return this.firePreventable(new import_events.MapWheelEvent(e.type, this.map, e));
  }
  mousedown(e, point) {
    this.mousedownPos = point;
    return this.firePreventable(new import_events.MapMouseEvent(e.type, this.map, e));
  }
  mouseup(e) {
    this.map.emit(e.type, new import_events.MapMouseEvent(e.type, this.map, e));
  }
  click(e, point) {
    if (this.mousedownPos && this.mousedownPos.dist(point) >= this.clickTolerance) {
      return;
    }
    this.map.emit(e.type, new import_events.MapMouseEvent(e.type, this.map, e));
  }
  dblclick(e) {
    return this.firePreventable(new import_events.MapMouseEvent(e.type, this.map, e));
  }
  mouseover(e) {
    this.map.emit(e.type, new import_events.MapMouseEvent(e.type, this.map, e));
  }
  mouseout(e) {
    this.map.emit(e.type, new import_events.MapMouseEvent(e.type, this.map, e));
  }
  touchstart(e) {
    return this.firePreventable(new import_events.MapTouchEvent(e.type, this.map, e));
  }
  touchmove(e) {
    this.map.emit(e.type, new import_events.MapTouchEvent(e.type, this.map, e));
  }
  touchend(e) {
    this.map.emit(e.type, new import_events.MapTouchEvent(e.type, this.map, e));
  }
  touchcancel(e) {
    this.map.emit(e.type, new import_events.MapTouchEvent(e.type, this.map, e));
  }
  firePreventable(mapEvent) {
    this.map.emit(mapEvent.type, mapEvent);
    if (mapEvent.defaultPrevented) {
      return {};
    }
  }
  isEnabled() {
    return true;
  }
  isActive() {
    return false;
  }
  enable() {
    return false;
  }
  disable() {
    return false;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
