var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/mouse/mouse_handler.ts
var mouse_handler_exports = {};
__export(mouse_handler_exports, {
  default: () => MouseHandler
});
module.exports = __toCommonJS(mouse_handler_exports);
var import_dom = __toESM(require("../../utils/dom"));
var import_util = require("./util");
var MouseHandler = class {
  constructor(options) {
    this.reset();
    this.clickTolerance = options.clickTolerance || 1;
  }
  reset() {
    this.active = false;
    this.moved = false;
    delete this.lastPoint;
    delete this.eventButton;
  }
  mousedown(e, point) {
    if (this.lastPoint) {
      return;
    }
    const eventButton = import_dom.default.mouseButton(e);
    if (!this.correctButton(e, eventButton)) {
      return;
    }
    this.lastPoint = point;
    this.eventButton = eventButton;
  }
  mousemoveWindow(e, point) {
    const lastPoint = this.lastPoint;
    if (!lastPoint) {
      return;
    }
    e.preventDefault();
    if ((0, import_util.buttonStillPressed)(e, this.eventButton)) {
      this.reset();
      return;
    }
    if (!this.moved && point.dist(lastPoint) < this.clickTolerance) {
      return;
    }
    this.moved = true;
    this.lastPoint = point;
    return this.move(lastPoint, point);
  }
  mouseupWindow(e) {
    if (!this.lastPoint) {
      return;
    }
    const eventButton = import_dom.default.mouseButton(e);
    if (eventButton !== this.eventButton) {
      return;
    }
    if (this.moved) {
      import_dom.default.suppressClick();
    }
    this.reset();
  }
  enable() {
    this.enabled = true;
  }
  disable() {
    this.enabled = false;
    this.reset();
  }
  isEnabled() {
    return this.enabled;
  }
  isActive() {
    return this.active;
  }
  correctButton(e, button) {
    return false;
  }
  move(lastPoint, point) {
    return;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
