var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/shim/touch_zoom_rotate.ts
var touch_zoom_rotate_exports = {};
__export(touch_zoom_rotate_exports, {
  default: () => TouchZoomRotateHandler
});
module.exports = __toCommonJS(touch_zoom_rotate_exports);
var import_l7_utils = require("@antv/l7-utils");
var TouchZoomRotateHandler = class {
  constructor(el, touchZoom, touchRotate, tapDragZoom) {
    this.el = el;
    this.touchZoom = touchZoom;
    this.touchRotate = touchRotate;
    this.tapDragZoom = tapDragZoom;
    this.rotationDisabled = false;
    this.enabled = true;
  }
  enable(options) {
    this.touchZoom.enable(options);
    if (!this.rotationDisabled) {
      this.touchRotate.enable(options);
    }
    this.tapDragZoom.enable();
    if (!import_l7_utils.isMini) {
      this.el.classList.add("l7-touch-zoom-rotate");
    }
  }
  disable() {
    this.touchZoom.disable();
    this.touchRotate.disable();
    this.tapDragZoom.disable();
    if (!import_l7_utils.isMini) {
      this.el.classList.remove("l7-touch-zoom-rotate");
    }
  }
  isEnabled() {
    return this.touchZoom.isEnabled() && (this.rotationDisabled || this.touchRotate.isEnabled()) && this.tapDragZoom.isEnabled();
  }
  isActive() {
    return this.touchZoom.isActive() || this.touchRotate.isActive() || this.tapDragZoom.isActive();
  }
  disableRotation() {
    this.rotationDisabled = true;
    this.touchRotate.disable();
  }
  enableRotation() {
    this.rotationDisabled = false;
    if (this.touchZoom.isEnabled()) {
      this.touchRotate.enable();
    }
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
