var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/tap/tap_drag_zoom.ts
var tap_drag_zoom_exports = {};
__export(tap_drag_zoom_exports, {
  default: () => TapDragZoomHandler
});
module.exports = __toCommonJS(tap_drag_zoom_exports);
var import_single_tap_recognizer = require("./single_tap_recognizer");
var import_tap_recognizer = __toESM(require("./tap_recognizer"));
var TapDragZoomHandler = class {
  constructor() {
    this.tap = new import_tap_recognizer.default({
      numTouches: 1,
      numTaps: 1
    });
    this.reset();
  }
  reset() {
    this.active = false;
    delete this.swipePoint;
    delete this.swipeTouch;
    delete this.tapTime;
    this.tap.reset();
  }
  touchstart(e, points, mapTouches) {
    if (this.swipePoint) {
      return;
    }
    if (this.tapTime && e.timeStamp - this.tapTime > import_single_tap_recognizer.MAX_TAP_INTERVAL) {
      this.reset();
    }
    if (!this.tapTime) {
      this.tap.touchstart(e, points, mapTouches);
    } else if (mapTouches.length > 0) {
      this.swipePoint = points[0];
      this.swipeTouch = mapTouches[0].identifier;
    }
  }
  touchmove(e, points, mapTouches) {
    if (!this.tapTime) {
      this.tap.touchmove(e, points, mapTouches);
    } else if (this.swipePoint) {
      if (mapTouches[0].identifier !== this.swipeTouch) {
        return;
      }
      const newSwipePoint = points[0];
      const dist = newSwipePoint.y - this.swipePoint.y;
      this.swipePoint = newSwipePoint;
      e.preventDefault();
      this.active = true;
      return {
        zoomDelta: dist / 128
      };
    }
  }
  touchend(e, points, mapTouches) {
    if (!this.tapTime) {
      const point = this.tap.touchend(e, points, mapTouches);
      if (point) {
        this.tapTime = e.timeStamp;
      }
    } else if (this.swipePoint) {
      if (mapTouches.length === 0) {
        this.reset();
      }
    }
  }
  touchcancel() {
    this.reset();
  }
  enable() {
    this.enabled = true;
  }
  disable() {
    this.enabled = false;
    this.reset();
  }
  isEnabled() {
    return this.enabled;
  }
  isActive() {
    return this.active;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
