var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/tap/tap_zoom.ts
var tap_zoom_exports = {};
__export(tap_zoom_exports, {
  default: () => TapZoomHandler
});
module.exports = __toCommonJS(tap_zoom_exports);
var import_tap_recognizer = __toESM(require("./tap_recognizer"));
var TapZoomHandler = class {
  constructor() {
    this.zoomIn = new import_tap_recognizer.default({
      numTouches: 1,
      numTaps: 2
    });
    this.zoomOut = new import_tap_recognizer.default({
      numTouches: 2,
      numTaps: 1
    });
    this.reset();
  }
  reset() {
    this.active = false;
    this.zoomIn.reset();
    this.zoomOut.reset();
  }
  touchstart(e, points, mapTouches) {
    this.zoomIn.touchstart(e, points, mapTouches);
    this.zoomOut.touchstart(e, points, mapTouches);
  }
  touchmove(e, points, mapTouches) {
    this.zoomIn.touchmove(e, points, mapTouches);
    this.zoomOut.touchmove(e, points, mapTouches);
  }
  touchend(e, points, mapTouches) {
    const zoomInPoint = this.zoomIn.touchend(e, points, mapTouches);
    const zoomOutPoint = this.zoomOut.touchend(e, points, mapTouches);
    if (zoomInPoint) {
      this.active = true;
      e.preventDefault();
      setTimeout(() => this.reset(), 0);
      return {
        cameraAnimation: (map) => map.easeTo({
          duration: 300,
          zoom: map.getZoom() + 1,
          around: map.unproject(zoomInPoint)
        }, { originalEvent: e })
      };
    } else if (zoomOutPoint) {
      this.active = true;
      e.preventDefault();
      setTimeout(() => this.reset(), 0);
      return {
        cameraAnimation: (map) => map.easeTo({
          duration: 300,
          zoom: map.getZoom() - 1,
          around: map.unproject(zoomOutPoint)
        }, { originalEvent: e })
      };
    }
  }
  touchcancel() {
    this.reset();
  }
  enable() {
    this.enabled = true;
  }
  disable() {
    this.enabled = false;
    this.reset();
  }
  isEnabled() {
    return this.enabled;
  }
  isActive() {
    return this.active;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
