var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/touch/touch_pan.ts
var touch_pan_exports = {};
__export(touch_pan_exports, {
  default: () => TouchPanHandler
});
module.exports = __toCommonJS(touch_pan_exports);
var import_point = __toESM(require("../../geo/point"));
var import_handler_util = require("../handler_util");
var TouchPanHandler = class {
  constructor(options) {
    this.minTouches = 1;
    this.clickTolerance = options.clickTolerance || 1;
    this.reset();
  }
  reset() {
    this.active = false;
    this.touches = {};
    this.sum = new import_point.default(0, 0);
  }
  touchstart(e, points, mapTouches) {
    return this.calculateTransform(e, points, mapTouches);
  }
  touchmove(e, points, mapTouches) {
    if (!this.active) {
      return;
    }
    e.preventDefault();
    return this.calculateTransform(e, points, mapTouches);
  }
  touchend(e, points, mapTouches) {
    this.calculateTransform(e, points, mapTouches);
    if (this.active && mapTouches.length < this.minTouches) {
      this.reset();
    }
  }
  touchcancel() {
    this.reset();
  }
  enable() {
    this.enabled = true;
  }
  disable() {
    this.enabled = false;
    this.reset();
  }
  isEnabled() {
    return this.enabled;
  }
  isActive() {
    return this.active;
  }
  calculateTransform(e, points, mapTouches) {
    if (mapTouches.length > 0) {
      this.active = true;
    }
    const touches = (0, import_handler_util.indexTouches)(mapTouches, points);
    const touchPointSum = new import_point.default(0, 0);
    const touchDeltaSum = new import_point.default(0, 0);
    let touchDeltaCount = 0;
    for (const identifier in touches) {
      if (touches[identifier]) {
        const point = touches[identifier];
        const prevPoint = this.touches[identifier];
        if (prevPoint) {
          touchPointSum._add(point);
          touchDeltaSum._add(point.sub(prevPoint));
          touchDeltaCount++;
          touches[identifier] = point;
        }
      }
    }
    this.touches = touches;
    if (touchDeltaCount < this.minTouches || !touchDeltaSum.mag()) {
      return;
    }
    const panDelta = touchDeltaSum.div(touchDeltaCount);
    this.sum._add(panDelta);
    if (this.sum.mag() < this.clickTolerance) {
      return;
    }
    const around = touchPointSum.div(touchDeltaCount);
    return {
      around,
      panDelta
    };
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
