var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/touch/touch_pitch.ts
var touch_pitch_exports = {};
__export(touch_pitch_exports, {
  default: () => TouchPitchHandler
});
module.exports = __toCommonJS(touch_pitch_exports);
var import_two_touch = __toESM(require("./two_touch"));
function isVertical(vector) {
  return Math.abs(vector.y) > Math.abs(vector.x);
}
var ALLOWED_SINGLE_TOUCH_TIME = 100;
var TouchPitchHandler = class extends import_two_touch.default {
  reset() {
    super.reset();
    this.valid = void 0;
    delete this.firstMove;
    delete this.lastPoints;
  }
  start(points) {
    this.lastPoints = points;
    if (isVertical(points[0].sub(points[1]))) {
      this.valid = false;
    }
  }
  move(points, center, e) {
    const vectorA = points[0].sub(this.lastPoints[0]);
    const vectorB = points[1].sub(this.lastPoints[1]);
    this.valid = this.gestureBeginsVertically(vectorA, vectorB, e.timeStamp);
    if (!this.valid) {
      return;
    }
    this.lastPoints = points;
    this.active = true;
    const yDeltaAverage = (vectorA.y + vectorB.y) / 2;
    const degreesPerPixelMoved = -0.5;
    return {
      pitchDelta: yDeltaAverage * degreesPerPixelMoved
    };
  }
  gestureBeginsVertically(vectorA, vectorB, timeStamp) {
    if (this.valid !== void 0) {
      return this.valid;
    }
    const threshold = 2;
    const movedA = vectorA.mag() >= threshold;
    const movedB = vectorB.mag() >= threshold;
    if (!movedA && !movedB) {
      return;
    }
    if (!movedA || !movedB) {
      if (this.firstMove === void 0) {
        this.firstMove = timeStamp;
      }
      if (timeStamp - this.firstMove < ALLOWED_SINGLE_TOUCH_TIME) {
        return void 0;
      } else {
        return false;
      }
    }
    const isSameDirection = vectorA.y > 0 === vectorB.y > 0;
    return isVertical(vectorA) && isVertical(vectorB) && isSameDirection;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
