var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/touch/touch_rotate.ts
var touch_rotate_exports = {};
__export(touch_rotate_exports, {
  default: () => TouchRotateHandler
});
module.exports = __toCommonJS(touch_rotate_exports);
var import_two_touch = __toESM(require("./two_touch"));
var ROTATION_THRESHOLD = 25;
function getBearingDelta(a, b) {
  return a.angleWith(b) * 180 / Math.PI;
}
var TouchRotateHandler = class extends import_two_touch.default {
  reset() {
    super.reset();
    delete this.minDiameter;
    delete this.startVector;
    delete this.vector;
  }
  start(points) {
    this.startVector = this.vector = points[0].sub(points[1]);
    this.minDiameter = points[0].dist(points[1]);
  }
  move(points, pinchAround) {
    const lastVector = this.vector;
    this.vector = points[0].sub(points[1]);
    if (!this.active && this.isBelowThreshold(this.vector)) {
      return;
    }
    this.active = true;
    return {
      bearingDelta: getBearingDelta(this.vector, lastVector),
      pinchAround
    };
  }
  isBelowThreshold(vector) {
    this.minDiameter = Math.min(this.minDiameter, vector.mag());
    const circumference = Math.PI * this.minDiameter;
    const threshold = ROTATION_THRESHOLD / circumference * 360;
    const bearingDeltaSinceStart = getBearingDelta(vector, this.startVector);
    return Math.abs(bearingDeltaSinceStart) < threshold;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
