var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/touch/touch_zoom.ts
var touch_zoom_exports = {};
__export(touch_zoom_exports, {
  default: () => TouchZoomHandler
});
module.exports = __toCommonJS(touch_zoom_exports);
var import_two_touch = __toESM(require("./two_touch"));
var ZOOM_THRESHOLD = 0.1;
function getZoomDelta(distance, lastDistance) {
  return Math.log(distance / lastDistance) / Math.LN2;
}
var TouchZoomHandler = class extends import_two_touch.default {
  reset() {
    super.reset();
    delete this.distance;
    delete this.startDistance;
  }
  start(points) {
    this.startDistance = this.distance = points[0].dist(points[1]);
  }
  move(points, pinchAround) {
    const lastDistance = this.distance;
    this.distance = points[0].dist(points[1]);
    if (!this.active && Math.abs(getZoomDelta(this.distance, this.startDistance)) < ZOOM_THRESHOLD) {
      return;
    }
    this.active = true;
    return {
      zoomDelta: getZoomDelta(this.distance, lastDistance),
      pinchAround
    };
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
