var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/handler/touch/two_touch.ts
var two_touch_exports = {};
__export(two_touch_exports, {
  default: () => TwoTouchHandler
});
module.exports = __toCommonJS(two_touch_exports);
var import_dom = __toESM(require("../../utils/dom"));
var TwoTouchHandler = class {
  constructor() {
    this.reset();
  }
  reset() {
    this.active = false;
    delete this.firstTwoTouches;
  }
  start(points) {
    return;
  }
  move(points, pinchAround, e) {
    return;
  }
  touchstart(e, points, mapTouches) {
    if (this.firstTwoTouches || mapTouches.length < 2) {
      return;
    }
    this.firstTwoTouches = [mapTouches[0].identifier, mapTouches[1].identifier];
    this.start([points[0], points[1]]);
  }
  touchmove(e, points, mapTouches) {
    if (!this.firstTwoTouches) {
      return;
    }
    e.preventDefault();
    const [idA, idB] = this.firstTwoTouches;
    const a = getTouchById(mapTouches, points, idA);
    const b = getTouchById(mapTouches, points, idB);
    if (!a || !b) {
      return;
    }
    const pinchAround = this.aroundCenter ? null : a.add(b).div(2);
    return this.move([a, b], pinchAround, e);
  }
  touchend(e, points, mapTouches) {
    if (!this.firstTwoTouches) {
      return;
    }
    const [idA, idB] = this.firstTwoTouches;
    const a = getTouchById(mapTouches, points, idA);
    const b = getTouchById(mapTouches, points, idB);
    if (a && b) {
      return;
    }
    if (this.active) {
      import_dom.default.suppressClick();
    }
    this.reset();
  }
  touchcancel() {
    this.reset();
  }
  enable(options) {
    this.enabled = true;
    this.aroundCenter = !!options && options.around === "center";
  }
  disable() {
    this.enabled = false;
    this.reset();
  }
  isEnabled() {
    return this.enabled;
  }
  isActive() {
    return this.active;
  }
};
function getTouchById(mapTouches, points, identifier) {
  for (let i = 0; i < mapTouches.length; i++) {
    if (mapTouches[i].identifier === identifier) {
      return points[i];
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
