var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/hash.ts
var hash_exports = {};
__export(hash_exports, {
  default: () => hash_default
});
module.exports = __toCommonJS(hash_exports);
var import_l7_utils = require("@antv/l7-utils");
var import_lodash = require("lodash");
var Hash = class {
  constructor(hashName) {
    this.onHashChange = () => {
      const loc = this.getCurrentHash();
      if (loc.length >= 3 && !loc.some((v) => isNaN(+v))) {
        const bearing = this.map.dragRotate.isEnabled() && this.map.touchZoomRotate.isEnabled() ? +(loc[3] || 0) : this.map.getBearing();
        this.map.jumpTo({
          center: [+loc[2], +loc[1]],
          zoom: +loc[0],
          bearing,
          pitch: +(loc[4] || 0)
        });
        return true;
      }
      return false;
    };
    this.getCurrentHash = () => {
      const hash = window.location.hash.replace("#", "");
      if (this.hashName) {
        let keyval;
        hash.split("&").map((part) => part.split("=")).forEach((part) => {
          if (part[0] === this.hashName) {
            keyval = part;
          }
        });
        return (keyval ? keyval[1] || "" : "").split("/");
      }
      return hash.split("/");
    };
    this.updateHashUnthrottled = () => {
      const hash = this.getHashString();
      try {
        window.history.replaceState(window.history.state, "", hash);
      } catch (SecurityError) {
      }
    };
    this.hashName = hashName && encodeURIComponent(hashName);
    this.updateHash = (0, import_lodash.throttle)(this.updateHashUnthrottled, 30 * 1e3 / 100);
  }
  addTo(map) {
    this.map = map;
    import_l7_utils.$window.addEventListener("hashchange", this.onHashChange, false);
    this.map.on("moveend", this.updateHash);
    return this;
  }
  remove() {
    import_l7_utils.$window.removeEventListener("hashchange", this.onHashChange, false);
    this.map.off("moveend", this.updateHash);
    delete this.map;
    return this;
  }
  getHashString(mapFeedback) {
    const center = this.map.getCenter();
    const zoom = Math.round(this.map.getZoom() * 100) / 100;
    const precision = Math.ceil((zoom * Math.LN2 + Math.log(512 / 360 / 0.5)) / Math.LN10);
    const m = Math.pow(10, precision);
    const lng = Math.round(center.lng * m) / m;
    const lat = Math.round(center.lat * m) / m;
    const bearing = this.map.getBearing();
    const pitch = this.map.getPitch();
    let hash = "";
    if (mapFeedback) {
      hash += `/${lng}/${lat}/${zoom}`;
    } else {
      hash += `${zoom}/${lat}/${lng}`;
    }
    if (bearing || pitch) {
      hash += `/${Math.round(bearing * 10) / 10}`;
    }
    if (pitch) {
      hash += `/${Math.round(pitch)}`;
    }
    if (this.hashName) {
      const hashName = this.hashName;
      let found = false;
      const parts = window.location.hash.slice(1).split("&").map((part) => {
        const key = part.split("=")[0];
        if (key === hashName) {
          found = true;
          return `${key}=${hash}`;
        }
        return part;
      }).filter((a) => a);
      if (!found) {
        parts.push(`${hashName}=${hash}`);
      }
      return `#${parts.join("&")}`;
    }
    return `#${hash}`;
  }
};
var hash_default = Hash;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
