var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/util.ts
var util_exports = {};
__export(util_exports, {
  bezier: () => bezier,
  cancel: () => cancel,
  clamp: () => clamp,
  ease: () => ease,
  interpolate: () => interpolate,
  now: () => now,
  pick: () => pick,
  prefersReducedMotion: () => prefersReducedMotion,
  raf: () => raf,
  renderframe: () => renderframe,
  wrap: () => wrap
});
module.exports = __toCommonJS(util_exports);
var import_l7_utils = require("@antv/l7-utils");
var import_unitbezier = __toESM(require("@mapbox/unitbezier"));
var reducedMotionQuery;
function wrap(n, min, max) {
  const d = max - min;
  const w = ((n - min) % d + d) % d + min;
  return w === min ? max : w;
}
function clamp(n, min, max) {
  return Math.min(max, Math.max(min, n));
}
function interpolate(a, b, t) {
  return a * (1 - t) + b * t;
}
function bezier(p1x, p1y, p2x, p2y) {
  const bez = new import_unitbezier.default(p1x, p1y, p2x, p2y);
  return (t) => {
    return bez.solve(t);
  };
}
var ease = bezier(0.25, 0.1, 0.25, 1);
function prefersReducedMotion() {
  if (import_l7_utils.isMini || !import_l7_utils.$window.matchMedia) {
    return false;
  }
  if (reducedMotionQuery == null) {
    reducedMotionQuery = import_l7_utils.$window.matchMedia("(prefers-reduced-motion: reduce)");
  }
  return reducedMotionQuery.matches;
}
function pick(src, properties) {
  const result = {};
  for (const name of properties) {
    if (name in src) {
      result[name] = src[name];
    }
  }
  return result;
}
var now = import_l7_utils.isMini ? Date.now.bind(Date) : import_l7_utils.$window.performance && import_l7_utils.$window.performance.now ? import_l7_utils.$window.performance.now.bind(import_l7_utils.$window.performance) : Date.now.bind(Date);
var raf = import_l7_utils.$window.requestAnimationFrame || import_l7_utils.$window.mozRequestAnimationFrame || import_l7_utils.$window.webkitRequestAnimationFrame || import_l7_utils.$window.msRequestAnimationFrame;
var cancel = import_l7_utils.$window.cancelAnimationFrame || import_l7_utils.$window.mozCancelAnimationFrame || import_l7_utils.$window.webkitCancelAnimationFrame || import_l7_utils.$window.msCancelAnimationFrame;
function renderframe(fn) {
  const frame = raf(fn);
  return { cancel: () => cancel(frame) };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  bezier,
  cancel,
  clamp,
  ease,
  interpolate,
  now,
  pick,
  prefersReducedMotion,
  raf,
  renderframe,
  wrap
});
