var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/Aabb.ts
var Aabb_exports = {};
__export(Aabb_exports, {
  default: () => Aabb
});
module.exports = __toCommonJS(Aabb_exports);
var import_gl_matrix = require("gl-matrix");
var Aabb = class {
  constructor(min, max) {
    this.min = min;
    this.max = max;
    this.center = import_gl_matrix.vec3.scale(new Float32Array(3), import_gl_matrix.vec3.add(new Float32Array(3), this.min, this.max), 0.5);
  }
  quadrant(index) {
    const split = [index % 2 === 0, index < 2];
    const qMin = import_gl_matrix.vec3.clone(this.min);
    const qMax = import_gl_matrix.vec3.clone(this.max);
    for (let axis = 0; axis < split.length; axis++) {
      qMin[axis] = split[axis] ? this.min[axis] : this.center[axis];
      qMax[axis] = split[axis] ? this.center[axis] : this.max[axis];
    }
    qMax[2] = this.max[2];
    return new Aabb(qMin, qMax);
  }
  distanceX(point) {
    const pointOnAabb = Math.max(Math.min(this.max[0], point[0]), this.min[0]);
    return pointOnAabb - point[0];
  }
  distanceY(point) {
    const pointOnAabb = Math.max(Math.min(this.max[1], point[1]), this.min[1]);
    return pointOnAabb - point[1];
  }
  intersects(frustum) {
    const aabbPoints = [
      [this.min[0], this.min[1], 0, 1],
      [this.max[0], this.min[1], 0, 1],
      [this.max[0], this.max[1], 0, 1],
      [this.min[0], this.max[1], 0, 1]
    ];
    let fullyInside = true;
    for (const plane of frustum.planes) {
      let pointsInside = 0;
      for (const i of aabbPoints) {
        pointsInside += import_gl_matrix.vec4.dot(plane, i) >= 0;
      }
      if (pointsInside === 0) {
        return 0;
      }
      if (pointsInside !== aabbPoints.length) {
        fullyInside = false;
      }
    }
    if (fullyInside) {
      return 2;
    }
    for (let axis = 0; axis < 3; axis++) {
      let projMin = Number.MAX_VALUE;
      let projMax = -Number.MAX_VALUE;
      for (const p of frustum.points) {
        const projectedPoint = p[axis] - this.min[axis];
        projMin = Math.min(projMin, projectedPoint);
        projMax = Math.max(projMax, projectedPoint);
      }
      if (projMax < 0 || projMin > this.max[axis] - this.min[axis]) {
        return 0;
      }
    }
    return 1;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
