var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/dom.ts
var dom_exports = {};
__export(dom_exports, {
  default: () => dom_default
});
module.exports = __toCommonJS(dom_exports);
var import_l7_utils = require("@antv/l7-utils");
var import_point = __toESM(require("../geo/point"));
var DOM = {};
var dom_default = DOM;
DOM.create = (tagName, className, container) => {
  const el = import_l7_utils.$window.document.createElement(tagName);
  if (className !== void 0) {
    el.className = className;
  }
  if (container) {
    container.appendChild(el);
  }
  return el;
};
DOM.createNS = (namespaceURI, tagName) => {
  const el = import_l7_utils.$window.document.createElementNS(namespaceURI, tagName);
  return el;
};
var docStyle = import_l7_utils.$window.document && import_l7_utils.$window.document.documentElement.style;
function testProp(props) {
  if (!docStyle) {
    return props[0];
  }
  for (const i of props) {
    if (i in docStyle) {
      return i;
    }
  }
  return props[0];
}
var selectProp = testProp([
  "userSelect",
  "MozUserSelect",
  "WebkitUserSelect",
  "msUserSelect"
]);
var userSelect;
DOM.disableDrag = () => {
  if (docStyle && selectProp) {
    userSelect = docStyle[selectProp];
    docStyle[selectProp] = "none";
  }
};
DOM.enableDrag = () => {
  if (docStyle && selectProp) {
    docStyle[selectProp] = userSelect;
  }
};
var transformProp = testProp(["transform", "WebkitTransform"]);
DOM.setTransform = (el, value) => {
  el.style[transformProp] = value;
};
var passiveSupported = false;
try {
  const options = Object.defineProperty({}, "passive", {
    get() {
      passiveSupported = true;
    }
  });
  import_l7_utils.$window.addEventListener("test", options, options);
  import_l7_utils.$window.removeEventListener("test", options, options);
} catch (err) {
  passiveSupported = false;
}
DOM.addEventListener = (target, type, callback, options = {}) => {
  if ("passive" in options && passiveSupported) {
    target.addEventListener(type, callback, options);
  } else {
    target.addEventListener(type, callback, options.capture);
  }
};
DOM.removeEventListener = (target, type, callback, options = {}) => {
  if ("passive" in options && passiveSupported) {
    target.removeEventListener(type, callback, options);
  } else {
    target.removeEventListener(type, callback, options.capture);
  }
};
var suppressClick = (e) => {
  e.preventDefault();
  e.stopPropagation();
  import_l7_utils.$window.removeEventListener("click", suppressClick, true);
};
DOM.suppressClick = () => {
  if (import_l7_utils.isMini) {
    return;
  }
  import_l7_utils.$window.addEventListener("click", suppressClick, true);
  setTimeout(() => {
    import_l7_utils.$window.removeEventListener("click", suppressClick, true);
  }, 0);
};
DOM.mousePos = (el, e) => {
  if (!import_l7_utils.isMini) {
    const rect = el.getBoundingClientRect();
    return new import_point.default(e.clientX - rect.left - el.clientLeft, e.clientY - rect.top - el.clientTop);
  } else {
    return new import_point.default(e.clientX - el.left - 0, e.clientY - el.top - 0);
  }
};
DOM.touchPos = (el, touches) => {
  if (!import_l7_utils.isMini) {
    const rect = el.getBoundingClientRect();
    const points = [];
    for (const touche of touches) {
      points.push(new import_point.default(touche.clientX - rect.left - el.clientLeft, touche.clientY - rect.top - el.clientTop));
    }
    return points;
  } else {
    const points = [];
    for (const touche of touches) {
      points.push(new import_point.default(touche.clientX - el.left, touche.clientY - el.top));
    }
    return points;
  }
};
DOM.mouseButton = (e) => {
  if (!import_l7_utils.isMini) {
    return e.button;
  }
  if (typeof import_l7_utils.$window.InstallTrigger !== "undefined" && e.button === 2 && e.ctrlKey && import_l7_utils.$window.navigator.platform.toUpperCase().indexOf("MAC") >= 0) {
    return 0;
  }
  return e.button;
};
DOM.remove = (node) => {
  if (node.parentNode) {
    node.parentNode.removeChild(node);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
