var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/performance.ts
var performance_exports = {};
__export(performance_exports, {
  PerformanceMarkers: () => PerformanceMarkers,
  PerformanceUtils: () => PerformanceUtils
});
module.exports = __toCommonJS(performance_exports);
var import_l7_utils = require("@antv/l7-utils");
var lastFrameTime = null;
var frameTimes = [];
var minFramerateTarget = 30;
var frameTimeTarget = 1e3 / minFramerateTarget;
var performance = import_l7_utils.$window.performance;
var PerformanceMarkers = {
  create: "create",
  load: "load",
  fullLoad: "fullLoad"
};
var PerformanceUtils = {
  mark(marker) {
    performance.mark(marker);
  },
  frame(timestamp) {
    const currTimestamp = timestamp;
    if (lastFrameTime != null) {
      const frameTime = currTimestamp - lastFrameTime;
      frameTimes.push(frameTime);
    }
    lastFrameTime = currTimestamp;
  },
  clearMetrics() {
    lastFrameTime = null;
    frameTimes = [];
    performance.clearMeasures("loadTime");
    performance.clearMeasures("fullLoadTime");
    for (const marker in PerformanceMarkers) {
      performance.clearMarks(PerformanceMarkers[marker]);
    }
  },
  getPerformanceMetrics() {
    const loadTime = performance.measure("loadTime", PerformanceMarkers.create, PerformanceMarkers.load).duration;
    const fullLoadTime = performance.measure("fullLoadTime", PerformanceMarkers.create, PerformanceMarkers.fullLoad).duration;
    const totalFrames = frameTimes.length;
    const avgFrameTime = frameTimes.reduce((prev, curr) => prev + curr, 0) / totalFrames / 1e3;
    const fps = 1 / avgFrameTime;
    const droppedFrames = frameTimes.filter((frameTime) => frameTime > frameTimeTarget).reduce((acc, curr) => {
      return acc + (curr - frameTimeTarget) / frameTimeTarget;
    }, 0);
    const percentDroppedFrames = droppedFrames / (totalFrames + droppedFrames) * 100;
    return {
      loadTime,
      fullLoadTime,
      fps,
      percentDroppedFrames
    };
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PerformanceMarkers,
  PerformanceUtils
});
