var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/primitives.ts
var primitives_exports = {};
__export(primitives_exports, {
  default: () => Frustum
});
module.exports = __toCommonJS(primitives_exports);
var import_gl_matrix = require("gl-matrix");
var Frustum = class {
  static fromInvProjectionMatrix(invProj, worldSize, zoom) {
    const clipSpaceCorners = [
      [-1, 1, -1, 1],
      [1, 1, -1, 1],
      [1, -1, -1, 1],
      [-1, -1, -1, 1],
      [-1, 1, 1, 1],
      [1, 1, 1, 1],
      [1, -1, 1, 1],
      [-1, -1, 1, 1]
    ];
    const scale = Math.pow(2, zoom);
    const frustumCoords = clipSpaceCorners.map((v) => import_gl_matrix.vec4.transformMat4(new Float32Array([]), v, invProj)).map((v) => import_gl_matrix.vec4.scale(new Float32Array([]), v, 1 / v[3] / worldSize * scale));
    const frustumPlanePointIndices = [
      [0, 1, 2],
      [6, 5, 4],
      [0, 3, 7],
      [2, 1, 5],
      [3, 2, 6],
      [0, 4, 5]
    ];
    const frustumPlanes = frustumPlanePointIndices.map((p) => {
      const a = import_gl_matrix.vec3.sub(new Float32Array(3), new Float32Array(frustumCoords[p[0]]), new Float32Array(frustumCoords[p[1]]));
      const b = import_gl_matrix.vec3.sub(new Float32Array(3), new Float32Array(frustumCoords[p[2]]), new Float32Array(frustumCoords[p[1]]));
      const n = import_gl_matrix.vec3.normalize(new Float32Array(3), import_gl_matrix.vec3.cross(new Float32Array(3), a, b));
      const d = -import_gl_matrix.vec3.dot(n, new Float32Array(frustumCoords[p[1]]));
      return n.concat(d);
    });
    return new Frustum(frustumCoords, frustumPlanes);
  }
  constructor(points, planes) {
    this.points = points;
    this.planes = planes;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
