var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/task_queue.ts
var task_queue_exports = {};
__export(task_queue_exports, {
  default: () => task_queue_default
});
module.exports = __toCommonJS(task_queue_exports);
var TaskQueue = class {
  constructor() {
    this.queue = [];
    this.id = 0;
    this.cleared = false;
    this.currentlyRunning = false;
  }
  add(callback) {
    const id = ++this.id;
    const queue = this.queue;
    queue.push({ callback, id, cancelled: false });
    return id;
  }
  remove(id) {
    const running = this.currentlyRunning;
    const queue = running ? this.queue.concat(running) : this.queue;
    for (const task of queue) {
      if (task.id === id) {
        task.cancelled = true;
        return;
      }
    }
  }
  run(timeStamp = 0) {
    const queue = this.currentlyRunning = this.queue;
    this.queue = [];
    for (const task of queue) {
      if (task.cancelled) {
        continue;
      }
      task.callback(timeStamp);
      if (this.cleared) {
        break;
      }
    }
    this.cleared = false;
    this.currentlyRunning = false;
  }
  clear() {
    if (this.currentlyRunning) {
      this.cleared = true;
    }
    this.queue = [];
  }
};
var task_queue_default = TaskQueue;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
